--- old/usr/src/uts/common/io/aac/aac.c	Thu Nov  1 14:48:24 2012
+++ new/usr/src/uts/common/io/aac/aac.c	Thu Nov  1 14:48:24 2012
@@ -6617,226 +6545,271 @@
  * Time sync. command added to synchronize time with firmware every 30
  * minutes (required for correct AIF timestamps etc.)
  */
-static void
+static int
 aac_sync_tick(struct aac_softstate *softs)
 {
-	ddi_acc_handle_t acc;
-	int rval;
+	ddi_acc_handle_t acc = softs->sync_slot->fib_acc_handle;
+	struct aac_fib *fibp = softs->sync_slot->fibp;
 
-	mutex_enter(&softs->time_mutex);
-	ASSERT(softs->time_sync <= softs->timebase);
-	softs->time_sync = 0;
-	mutex_exit(&softs->time_mutex);
-
-	/* Time sync. with firmware every AAC_SYNC_TICK */
-	(void) aac_sync_fib_slot_bind(softs, &softs->sync_ac);
-	acc = softs->sync_ac.slotp->fib_acc_handle;
-
-	ddi_put32(acc, (void *)&softs->sync_ac.slotp->fibp->data[0],
-	    ddi_get_time());
-	rval = aac_sync_fib(softs, SendHostTime, AAC_FIB_SIZEOF(uint32_t));
-	aac_sync_fib_slot_release(softs, &softs->sync_ac);
-
-	mutex_enter(&softs->time_mutex);
-	softs->time_sync = softs->timebase;
-	if (rval != AACOK)
-		/* retry shortly */
-		softs->time_sync += aac_tick << 1;
-	else
-		softs->time_sync += AAC_SYNC_TICK;
-	mutex_exit(&softs->time_mutex);
+	ddi_put32(acc, (uint32_t *)&fibp->data[0], ddi_get_time());
+	return (aac_sync_fib(softs, SendHostTime, AAC_FIB_SIZEOF(uint32_t)));
 }
 
-/*
- * Timeout checking and handling
- */
 static void
-aac_daemon(struct aac_softstate *softs)
+aac_daemon(void *arg)
 {
-	int time_out; /* set if timeout happened */
-	int time_adjust;
-	uint32_t softs_timebase;
+	struct aac_softstate *softs = (struct aac_softstate *)arg;
+	struct aac_cmd *acp;
 
-	mutex_enter(&softs->time_mutex);
-	ASSERT(softs->time_out <= softs->timebase);
-	softs->time_out = 0;
-	softs_timebase = softs->timebase;
-	mutex_exit(&softs->time_mutex);
+	DBCALLED(softs, 2);
 
-	/* Check slots for timeout pkts */
-	time_adjust = 0;
-	do {
-		struct aac_cmd *acp;
-
-		time_out = 0;
-		for (acp = softs->q_busy.q_head; acp; acp = acp->next) {
-			if (acp->timeout == 0)
-				continue;
-
-			/*
-			 * If timeout happened, update outstanding cmds
-			 * to be checked later again.
-			 */
-			if (time_adjust) {
-				acp->timeout += time_adjust;
-				continue;
-			}
-
-			if (acp->timeout <= softs_timebase) {
+	mutex_enter(&softs->io_lock);
+	/* Check slot for timeout pkts */
+	aac_timebase += aac_tick;
+	for (acp = softs->q_busy.q_head; acp; acp = acp->next) {
+		if (acp->timeout) {
+			if (acp->timeout <= aac_timebase) {
 				aac_cmd_timeout(softs, acp);
-				time_out = 1;
-				time_adjust = aac_tick * drv_usectohz(1000000);
-				break; /* timeout happened */
-			} else {
-				break; /* no timeout */
+				ddi_trigger_softintr(softs->softint_id);
 			}
+			break;
 		}
-	} while (time_out);
+	}
 
-	mutex_enter(&softs->time_mutex);
-	softs->time_out = softs->timebase + aac_tick;
-	mutex_exit(&softs->time_mutex);
+	/* Time sync. with firmware every AAC_SYNC_TICK */
+	if (aac_sync_time <= aac_timebase) {
+		aac_sync_time = aac_timebase;
+		if (aac_sync_tick(softs) != AACOK)
+			aac_sync_time += aac_tick << 1; /* retry shortly */
+		else
+			aac_sync_time += AAC_SYNC_TICK;
+	}
+
+	if ((softs->state & AAC_STATE_RUN) && (softs->timeout_id != 0))
+		softs->timeout_id = timeout(aac_daemon, (void *)softs,
+		    (aac_tick * drv_usectohz(1000000)));
+	mutex_exit(&softs->io_lock);
 }
 
 /*
- * The event thread handles various tasks serially for the other parts of
- * the driver, so that they can run fast.
+ * Architecture dependent functions
  */
-static void
-aac_event_thread(struct aac_softstate *softs)
+static void 
+aac_rx_set_intr(struct aac_softstate *softs, int enable)
 {
-	int run = 1;
+	if (enable) {
+    	if (softs->flags & AAC_FLAGS_NEW_COMM)
+			PCI_MEM_PUT32(softs, 0, AAC_OIMR, ~AAC_DB_INTR_NEW);
+		else
+			PCI_MEM_PUT32(softs, 0, AAC_OIMR, ~AAC_DB_INTR_BITS);
+	} else {
+		PCI_MEM_PUT32(softs, 0, AAC_OIMR, ~0);
+	}
+}
 
-	DBCALLED(softs, 1);
+static void 
+aac_rx_status_clr(struct aac_softstate *softs, int mask)
+{
+	PCI_MEM_PUT32(softs, 0, AAC_ODBR, mask);
+}
 
-	mutex_enter(&softs->ev_lock);
-	while (run) {
-		int events;
+static int 
+aac_rx_status_get(struct aac_softstate *softs)
+{
+	return (PCI_MEM_GET32(softs, 0, AAC_ODBR));
+}
 
-		if ((events = softs->events) == 0) {
-			cv_wait(&softs->event_disp_cv, &softs->ev_lock);
-			events = softs->events;
-		}
-		softs->events = 0;
-		mutex_exit(&softs->ev_lock);
+static void 
+aac_rx_notify(struct aac_softstate *softs, int val)
+{
+	PCI_MEM_PUT32(softs, 0, AAC_IDBR, val);
+}
 
-		mutex_enter(&softs->io_lock);
-		if ((softs->state & AAC_STATE_RUN) &&
-		    (softs->state & AAC_STATE_DEAD) == 0) {
-			if (events & AAC_EVENT_TIMEOUT)
-				aac_daemon(softs);
-			if (events & AAC_EVENT_SYNCTICK)
-				aac_sync_tick(softs);
-			if (events & AAC_EVENT_AIF)
-				aac_aif_event(softs);
-		} else {
-			run = 0;
-		}
-		mutex_exit(&softs->io_lock);
+static int
+aac_rx_get_fwstatus(struct aac_softstate *softs)
+{
+	return (PCI_MEM_GET32(softs, 0, AAC_OMR0));
+}
 
-		mutex_enter(&softs->ev_lock);
-	}
-
-	cv_signal(&softs->event_wait_cv);
-	mutex_exit(&softs->ev_lock);
+static int
+aac_rx_get_mailbox(struct aac_softstate *softs, int mb)
+{
+	return (PCI_MEM_GET32(softs, 0, AAC_RX_MAILBOX + mb * 4));
 }
 
-/*
- * Internal timer. It is only responsbile for time counting and report time
- * related events. Events handling is done by aac_event_thread(), so that
- * the timer itself could be as precise as possible.
- */
 static void
-aac_timer(void *arg)
+aac_rx_set_mailbox(struct aac_softstate *softs, uint32_t cmd,
+    uint32_t arg0, uint32_t arg1, uint32_t arg2, uint32_t arg3)
 {
-	struct aac_softstate *softs = arg;
-	int events = 0;
+	PCI_MEM_PUT32(softs, 0, AAC_RX_MAILBOX, cmd);
+	PCI_MEM_PUT32(softs, 0, AAC_RX_MAILBOX + 4, arg0);
+	PCI_MEM_PUT32(softs, 0, AAC_RX_MAILBOX + 8, arg1);
+	PCI_MEM_PUT32(softs, 0, AAC_RX_MAILBOX + 12, arg2);
+	PCI_MEM_PUT32(softs, 0, AAC_RX_MAILBOX + 16, arg3);
+}
 
-	mutex_enter(&softs->time_mutex);
+static int
+aac_rx_send_command(struct aac_softstate *softs, struct aac_slot *slotp)
+{
+	uint32_t index, device;
 
-	/* If timer is being stopped, exit */
-	if (softs->timeout_id) {
-		softs->timeout_id = timeout(aac_timer, (void *)softs,
-		    (aac_tick * drv_usectohz(1000000)));
-	} else {
-		mutex_exit(&softs->time_mutex);
-		return;
+	index = PCI_MEM_GET32(softs, 0, AAC_IQUE);
+	if (index == 0xffffffffUL) {
+		index = PCI_MEM_GET32(softs, 0, AAC_IQUE);
+		if (index == 0xffffffffUL)
+			return (AACERR);
 	}
 
-	/* Time counting */
-	softs->timebase += aac_tick;
+	device = index;
+	PCI_MEM_PUT32(softs, 0, device,
+	    (uint32_t)(slotp->fib_phyaddr & 0xfffffffful));
+	device += 4;
+	PCI_MEM_PUT32(softs, 0, device, (uint32_t)(slotp->fib_phyaddr >> 32));
+	device += 4;
+	PCI_MEM_PUT32(softs, 0, device, slotp->acp->fib_size);
+	PCI_MEM_PUT32(softs, 0, AAC_IQUE, index);
+	return (AACOK);
+}
 
-	/* Check time related events */
-	if (softs->time_out && softs->time_out <= softs->timebase)
-		events |= AAC_EVENT_TIMEOUT;
-	if (softs->time_sync && softs->time_sync <= softs->timebase)
-		events |= AAC_EVENT_SYNCTICK;
+static int
+aac_rkt_get_fwstatus(struct aac_softstate *softs)
+{
+	return (PCI_MEM_GET32(softs, 0, AAC_OMR0));
+}
 
-	mutex_exit(&softs->time_mutex);
-
-	if (events)
-		aac_event_disp(softs, events);
+static int
+aac_rkt_get_mailbox(struct aac_softstate *softs, int mb)
+{
+	return (PCI_MEM_GET32(softs, 0, AAC_RKT_MAILBOX + mb *4));
 }
 
-/*
- * Dispatch events to daemon thread for handling
- */
 static void
-aac_event_disp(struct aac_softstate *softs, int events)
+aac_rkt_set_mailbox(struct aac_softstate *softs, uint32_t cmd,
+    uint32_t arg0, uint32_t arg1, uint32_t arg2, uint32_t arg3)
 {
-	mutex_enter(&softs->ev_lock);
-	softs->events |= events;
-	cv_broadcast(&softs->event_disp_cv);
-	mutex_exit(&softs->ev_lock);
+	PCI_MEM_PUT32(softs, 0, AAC_RKT_MAILBOX, cmd);
+	PCI_MEM_PUT32(softs, 0, AAC_RKT_MAILBOX + 4, arg0);
+	PCI_MEM_PUT32(softs, 0, AAC_RKT_MAILBOX + 8, arg1);
+	PCI_MEM_PUT32(softs, 0, AAC_RKT_MAILBOX + 12, arg2);
+	PCI_MEM_PUT32(softs, 0, AAC_RKT_MAILBOX + 16, arg3);
 }
 
-/*
- * Architecture dependent functions
- */
+static void 
+aac_src_set_intr(struct aac_softstate *softs, int enable)
+{
+	if (enable) {
+		PCI_MEM_PUT32(softs, 0, AAC_SRC_OIMR, ~AAC_DB_INTR_NEW_TYPE1);
+	} else {
+		PCI_MEM_PUT32(softs, 0, AAC_SRC_OIMR, ~0);
+	}
+}
+
+static void 
+aac_src_status_clr(struct aac_softstate *softs, int mask)
+{
+	PCI_MEM_PUT32(softs, 0, AAC_SRC_ODBR_C, mask << AAC_SRC_ODR_SHIFT);
+}
+
+static int 
+aac_src_status_get(struct aac_softstate *softs)
+{
+	return (PCI_MEM_GET32(softs, 0, AAC_SRC_ODBR_R) >> AAC_SRC_ODR_SHIFT);
+}
+
+static void 
+aac_src_notify(struct aac_softstate *softs, int val)
+{
+	PCI_MEM_PUT32(softs, 0, AAC_SRC_IDBR, val << AAC_SRC_IDR_SHIFT);
+}
+
 static int
-aac_rx_get_fwstatus(struct aac_softstate *softs)
+aac_src_get_fwstatus(struct aac_softstate *softs)
 {
-	return (PCI_MEM_GET32(softs, AAC_OMR0));
+	return (PCI_MEM_GET32(softs, 0, AAC_SRC_OMR));
 }
 
 static int
-aac_rx_get_mailbox(struct aac_softstate *softs, int mb)
+aac_src_get_mailbox(struct aac_softstate *softs, int mb)
 {
-	return (PCI_MEM_GET32(softs, AAC_RX_MAILBOX + mb * 4));
+	return (PCI_MEM_GET32(softs, 0, AAC_SRC_MAILBOX + mb *4));
 }
 
 static void
-aac_rx_set_mailbox(struct aac_softstate *softs, uint32_t cmd,
+aac_src_set_mailbox(struct aac_softstate *softs, uint32_t cmd,
     uint32_t arg0, uint32_t arg1, uint32_t arg2, uint32_t arg3)
 {
-	PCI_MEM_PUT32(softs, AAC_RX_MAILBOX, cmd);
-	PCI_MEM_PUT32(softs, AAC_RX_MAILBOX + 4, arg0);
-	PCI_MEM_PUT32(softs, AAC_RX_MAILBOX + 8, arg1);
-	PCI_MEM_PUT32(softs, AAC_RX_MAILBOX + 12, arg2);
-	PCI_MEM_PUT32(softs, AAC_RX_MAILBOX + 16, arg3);
+	PCI_MEM_PUT32(softs, 0, AAC_SRC_MAILBOX, cmd);
+	PCI_MEM_PUT32(softs, 0, AAC_SRC_MAILBOX + 4, arg0);
+	PCI_MEM_PUT32(softs, 0, AAC_SRC_MAILBOX + 8, arg1);
+	PCI_MEM_PUT32(softs, 0, AAC_SRC_MAILBOX + 12, arg2);
+	PCI_MEM_PUT32(softs, 0, AAC_SRC_MAILBOX + 16, arg3);
 }
 
 static int
-aac_rkt_get_fwstatus(struct aac_softstate *softs)
+aac_src_send_command(struct aac_softstate *softs, struct aac_slot *slotp)
 {
-	return (PCI_MEM_GET32(softs, AAC_OMR0));
+	ddi_acc_handle_t acc = slotp->fib_acc_handle;
+	uint32_t fibsize, hdr_size, high_addr;
+	uint64_t address;
+
+	hdr_size = (uint32_t)ddi_get16(acc, &slotp->fibp->Header.Size);
+	if (softs->flags & AAC_FLAGS_NEW_COMM_TYPE2) {
+		struct aac_fib *fibp = slotp->fibp;
+
+		/* Calculate the amount to the fibsize bits */
+		fibsize = (hdr_size + 127) / 128 - 1; 
+		/* New FIB header */
+		address = slotp->fib_phyaddr;
+		high_addr = (uint32_t)(address >> 32);
+		if (high_addr == 0L) {
+			ddi_put8(acc, &fibp->Header.StructType, AAC_FIBTYPE_TFIB2);
+			ddi_put32(acc, &fibp->Header.a.TimeStamp, 0L);
+		} else {
+			ddi_put8(acc, &fibp->Header.StructType, AAC_FIBTYPE_TFIB2_64);
+			ddi_put32(acc, &fibp->Header.a.SenderFibAddressHigh, high_addr);
+		}
+		ddi_put32(acc, &fibp->Header.SenderFibAddress, (uint32_t)address);
+	} else {
+		struct aac_fib_xporthdr *pFibX;
+
+		/* Calculate the amount to the fibsize bits */
+		fibsize = (sizeof(struct aac_fib_xporthdr) + hdr_size + 127) / 128 - 1; 
+		/* Fill XPORT header */ 
+		address = slotp->fib_phyaddr - sizeof(struct aac_fib_xporthdr);
+		high_addr = (uint32_t)(address >> 32);
+		pFibX = (struct aac_fib_xporthdr *)
+			((unsigned char *)slotp->fibp - sizeof(struct aac_fib_xporthdr));
+		ddi_put32(acc, &pFibX->Handle, slotp->index + 1);
+		ddi_put64(acc, &pFibX->HostAddress, slotp->fib_phyaddr);
+		ddi_put32(acc, &pFibX->Size, hdr_size);
+	}
+
+	if (fibsize > 31) 
+		fibsize = 31;
+	if (high_addr) {
+		PCI_MEM_PUT32(softs, 0, AAC_SRC_IQUE64_H, high_addr);
+		PCI_MEM_PUT32(softs, 0, AAC_SRC_IQUE64_L, (uint32_t)address + fibsize);
+	} else {
+		PCI_MEM_PUT32(softs, 0, AAC_SRC_IQUE32, (uint32_t)address + fibsize);
+	}
+	return (AACOK);
 }
 
 static int
-aac_rkt_get_mailbox(struct aac_softstate *softs, int mb)
+aac_srcv_get_mailbox(struct aac_softstate *softs, int mb)
 {
-	return (PCI_MEM_GET32(softs, AAC_RKT_MAILBOX + mb *4));
+	return (PCI_MEM_GET32(softs, 0, AAC_SRCV_MAILBOX + mb *4));
 }
 
 static void
-aac_rkt_set_mailbox(struct aac_softstate *softs, uint32_t cmd,
+aac_srcv_set_mailbox(struct aac_softstate *softs, uint32_t cmd,
     uint32_t arg0, uint32_t arg1, uint32_t arg2, uint32_t arg3)
 {
-	PCI_MEM_PUT32(softs, AAC_RKT_MAILBOX, cmd);
-	PCI_MEM_PUT32(softs, AAC_RKT_MAILBOX + 4, arg0);
-	PCI_MEM_PUT32(softs, AAC_RKT_MAILBOX + 8, arg1);
-	PCI_MEM_PUT32(softs, AAC_RKT_MAILBOX + 12, arg2);
-	PCI_MEM_PUT32(softs, AAC_RKT_MAILBOX + 16, arg3);
+	PCI_MEM_PUT32(softs, 0, AAC_SRCV_MAILBOX, cmd);
+	PCI_MEM_PUT32(softs, 0, AAC_SRCV_MAILBOX + 4, arg0);
+	PCI_MEM_PUT32(softs, 0, AAC_SRCV_MAILBOX + 8, arg1);
+	PCI_MEM_PUT32(softs, 0, AAC_SRCV_MAILBOX + 12, arg2);
+	PCI_MEM_PUT32(softs, 0, AAC_SRCV_MAILBOX + 16, arg3);
 }
 
 /*
@@ -6923,6 +6896,21 @@
 	return (ENXIO);
 }
 
+static int
+aac_atoi(char **pptr)
+{
+	char *ptr = *pptr;
+	int digit, rval = 0;
+
+	while (*ptr >= '0' && *ptr <= '9') {
+		digit = (int)(*ptr - '0');
+		rval = rval*10 + digit;
+		ptr++;
+	}
+	*pptr = ptr;
+	return (rval);
+}
+
 /*
  * The IO fault service error handling callback function
  */
@@ -6950,17 +6938,23 @@
 	 */
 	ddi_iblock_cookie_t fm_ibc;
 
+	if (!aac_fm_valid)
+		return;
+
+	/*
+	 * Initialize FMA
+	 */
 	softs->fm_capabilities = ddi_getprop(DDI_DEV_T_ANY, softs->devinfo_p,
-	    DDI_PROP_CANSLEEP | DDI_PROP_DONTPASS, "fm-capable",
-	    DDI_FM_EREPORT_CAPABLE | DDI_FM_ACCCHK_CAPABLE |
-	    DDI_FM_DMACHK_CAPABLE | DDI_FM_ERRCB_CAPABLE);
+		DDI_PROP_CANSLEEP | DDI_PROP_DONTPASS, "fm-capable",
+		DDI_FM_EREPORT_CAPABLE | DDI_FM_ACCCHK_CAPABLE |
+		DDI_FM_DMACHK_CAPABLE | DDI_FM_ERRCB_CAPABLE);
 
 	/* Only register with IO Fault Services if we have some capability */
 	if (softs->fm_capabilities) {
 		/* Adjust access and dma attributes for FMA */
-		softs->reg_attr.devacc_attr_access = DDI_FLAGERR_ACC;
-		softs->addr_dma_attr.dma_attr_flags |= DDI_DMA_FLAGERR;
-		softs->buf_dma_attr.dma_attr_flags |= DDI_DMA_FLAGERR;
+		aac_acc_attr.devacc_attr_access = DDI_FLAGERR_ACC;
+		softs->buf_dma_attr.dma_attr_flags = DDI_DMA_FLAGERR;
+		softs->addr_dma_attr.dma_attr_flags = DDI_DMA_FLAGERR;
 
 		/*
 		 * Register capabilities with IO Fault Services.
@@ -6985,6 +6979,11 @@
 			ddi_fm_handler_register(softs->devinfo_p,
 			    aac_fm_error_cb, (void *) softs);
 		}
+	} else {
+		/* Clear FMA if no capabilities */
+		aac_acc_attr.devacc_attr_access = DDI_DEFAULT_ACC;
+		softs->buf_dma_attr.dma_attr_flags = 0;
+		softs->addr_dma_attr.dma_attr_flags = 0;
 	}
 }
 
@@ -6995,6 +6994,9 @@
 static void
 aac_fm_fini(struct aac_softstate *softs)
 {
+	if (!aac_fm_valid)
+		return;
+
 	/* Only unregister FMA capabilities if registered */
 	if (softs->fm_capabilities) {
 		/*
@@ -7014,11 +7016,6 @@
 
 		/* Unregister from IO Fault Services */
 		ddi_fm_fini(softs->devinfo_p);
-
-		/* Adjust access and dma attributes for FMA */
-		softs->reg_attr.devacc_attr_access = DDI_DEFAULT_ACC;
-		softs->addr_dma_attr.dma_attr_flags &= ~DDI_DMA_FLAGERR;
-		softs->buf_dma_attr.dma_attr_flags &= ~DDI_DMA_FLAGERR;
 	}
 }
 
@@ -7027,6 +7024,9 @@
 {
 	ddi_fm_error_t de;
 
+	if (!aac_fm_valid)
+		return (DDI_SUCCESS);
+
 	ddi_fm_acc_err_get(handle, &de, DDI_FME_VERSION);
 	return (de.fme_status);
 }
@@ -7036,16 +7036,22 @@
 {
 	ddi_fm_error_t de;
 
+	if (!aac_fm_valid)
+		return (DDI_SUCCESS);
+
 	ddi_fm_dma_err_get(handle, &de, DDI_FME_VERSION);
 	return (de.fme_status);
 }
 
 void
-aac_fm_ereport(struct aac_softstate *softs, char *detail)
+aac_fm_ereport(struct aac_softstate *softs, char *detail, int impact)
 {
 	uint64_t ena;
 	char buf[FM_MAX_CLASS];
 
+	if (!aac_fm_valid)
+		return;
+
 	(void) snprintf(buf, FM_MAX_CLASS, "%s.%s", DDI_FM_DEVICE, detail);
 	ena = fm_ena_generate(0, FM_ENA_FMT1);
 	if (DDI_FM_EREPORT_CAP(softs->fm_capabilities)) {
@@ -7052,6 +7058,7 @@
 		ddi_fm_ereport_post(softs->devinfo_p, buf, ena, DDI_NOSLEEP,
 		    FM_VERSION, DATA_TYPE_UINT8, FM_EREPORT_VERSION, NULL);
 	}
+	ddi_fm_service_impact(softs->devinfo_p, impact);
 }
 
 /*
@@ -7100,34 +7107,27 @@
 }
 
 static dev_info_t *
-aac_find_child(struct aac_softstate *softs, uint16_t tgt, uint8_t lun)
+aac_find_child(struct aac_softstate *softs, int tgt, int lun)
 {
-	dev_info_t *child = NULL;
 	char addr[SCSI_MAXNAMELEN];
-	char tmp[MAXNAMELEN];
+	dev_info_t *child;
+	char *tmp;
 
 	if (tgt < AAC_MAX_LD) {
-		if (lun == 0) {
-			struct aac_device *dvp = &softs->containers[tgt].dev;
+		struct aac_device *dvp = &softs->containers[tgt].dev;
 
-			child = dvp->dip;
-		}
+		if (lun == 0 && dvp->valid)
+			return (dvp->dip);
 	} else {
 		(void) sprintf(addr, "%x,%x", tgt, lun);
 		for (child = ddi_get_child(softs->devinfo_p);
 		    child; child = ddi_get_next_sibling(child)) {
-			/* We don't care about non-persistent node */
-			if (ndi_dev_is_persistent_node(child) == 0)
-				continue;
-
-			if (aac_name_node(child, tmp, MAXNAMELEN) !=
-			    DDI_SUCCESS)
-				continue;
-			if (strcmp(addr, tmp) == 0)
-				break;
+			if ((tmp = ddi_get_name_addr(child)) != NULL &&
+			    strcmp(addr, tmp) == 0)
+				return (child);
 		}
 	}
-	return (child);
+	return (NULL);
 }
 
 static int
@@ -7137,7 +7137,6 @@
 	char *nodename = NULL;
 	char **compatible = NULL;
 	int ncompatible = 0;
-	char *childname;
 	dev_info_t *ldip = NULL;
 	int tgt = sd->sd_address.a_target;
 	int lun = sd->sd_address.a_lun;
@@ -7150,14 +7149,15 @@
 	    NULL, &nodename, &compatible, &ncompatible);
 	if (nodename == NULL) {
 		AACDB_PRINT(softs, CE_WARN,
-		    "found no comptible driver for t%dL%d", tgt, lun);
+		    "found no compatible driver for t%dL%d", tgt, lun);
 		rval = NDI_FAILURE;
 		goto finish;
 	}
-	childname = (softs->legacy && dtype == DTYPE_DIRECT) ? "sd" : nodename;
+	if (softs->legacy && dtype == DTYPE_DIRECT)
+		nodename = "sd";
 
 	/* Create dev node */
-	rval = ndi_devi_alloc(softs->devinfo_p, childname, DEVI_SID_NODEID,
+	rval = ndi_devi_alloc(softs->devinfo_p, nodename, DEVI_SID_NODEID,
 	    &ldip);
 	if (rval == NDI_SUCCESS) {
 		if (ndi_prop_update_int(DDI_DEV_T_NONE, ldip, "target", tgt)
@@ -7194,8 +7194,6 @@
 finish:
 	if (dipp)
 		*dipp = ldip;
-
-	scsi_hba_nodename_compatible_free(nodename, compatible);
 	return (rval);
 }
 
@@ -7208,59 +7206,32 @@
 
 	DBCALLED(softs, 2);
 
-	if (tgt < AAC_MAX_LD) {
-		enum aac_cfg_event event;
+	if (tgt < AAC_MAX_LD && lun != 0)
+		return (NDI_FAILURE);
 
-		if (lun == 0) {
-			mutex_enter(&softs->io_lock);
-			event = aac_probe_container(softs, tgt);
-			mutex_exit(&softs->io_lock);
-			if ((event != AAC_CFG_NULL_NOEXIST) &&
-			    (event != AAC_CFG_DELETE)) {
-				if (scsi_hba_probe(sd, NULL) ==
-				    SCSIPROBE_EXISTS)
-					return (NDI_SUCCESS);
-			}
-		}
+	if (scsi_hba_probe(sd, NULL) != SCSIPROBE_EXISTS)
 		return (NDI_FAILURE);
-	} else {
-		int dtype;
-		int qual; /* device qualifier */
+	if (tgt >= AAC_MAX_LD) {
+		int dtype = sd->sd_inq->inq_dtype & DTYPE_MASK;
 
-		if (scsi_hba_probe(sd, NULL) != SCSIPROBE_EXISTS)
-			return (NDI_FAILURE);
-
-		dtype = sd->sd_inq->inq_dtype & DTYPE_MASK;
-		qual = dtype >> 5;
-
 		AACDB_PRINT(softs, CE_NOTE,
 		    "Phys. device found: tgt %d dtype %d: %s",
 		    tgt, dtype, sd->sd_inq->inq_vid);
 
-		/* Only non-DASD and JBOD mode DASD are allowed exposed */
-		if (dtype == DTYPE_RODIRECT /* CDROM */ ||
-		    dtype == DTYPE_SEQUENTIAL /* TAPE */ ||
-		    dtype == DTYPE_ESI /* SES */) {
-			if (!(softs->flags & AAC_FLAGS_NONDASD))
-				return (NDI_FAILURE);
-			AACDB_PRINT(softs, CE_NOTE, "non-DASD %d found", tgt);
-
-		} else if (dtype == DTYPE_DIRECT) {
-			if (!(softs->flags & AAC_FLAGS_JBOD) || qual != 0)
-				return (NDI_FAILURE);
-			AACDB_PRINT(softs, CE_NOTE, "JBOD DASD %d found", tgt);
-		}
-
-		mutex_enter(&softs->io_lock);
-		softs->nondasds[AAC_PD(tgt)].dev.flags |= AAC_DFLAG_VALID;
-		mutex_exit(&softs->io_lock);
-		return (NDI_SUCCESS);
+		/* Only non-DASD and JBOD devices exposed */
+		if (dtype != DTYPE_RODIRECT /* CDROM */ &&
+		    dtype != DTYPE_SEQUENTIAL /* TYPE */ &&
+		    dtype != DTYPE_ESI /* SES */ &&
+			!(dtype == DTYPE_DIRECT && 
+			 (softs->aac_feature_bits & AAC_SUPPL_SUPPORTED_JBOD)))
+			return (NDI_FAILURE);
+		AACDB_PRINT(softs, CE_NOTE, "non-DASD/JBOD %d found", tgt);
 	}
+	return (NDI_SUCCESS);
 }
 
 static int
-aac_config_lun(struct aac_softstate *softs, uint16_t tgt, uint8_t lun,
-    dev_info_t **ldip)
+aac_config_lun(struct aac_softstate *softs, int tgt, int lun, dev_info_t **ldip)
 {
 	struct scsi_device sd;
 	dev_info_t *child;
@@ -7280,11 +7251,7 @@
 	sd.sd_address.a_lun = (uint8_t)lun;
 	if ((rval = aac_probe_lun(softs, &sd)) == NDI_SUCCESS)
 		rval = aac_config_child(softs, &sd, ldip);
-	/* scsi_unprobe is blank now. Free buffer manually */
-	if (sd.sd_inq) {
-		kmem_free(sd.sd_inq, SUN_INQSIZE);
-		sd.sd_inq = (struct scsi_inquiry *)NULL;
-	}
+	scsi_unprobe(&sd);
 	return (rval);
 }
 
@@ -7293,11 +7260,10 @@
 {
 	struct scsi_address ap;
 	struct buf *bp = NULL;
-	int buf_len = AAC_SCSI_RPTLUNS_HEAD_SIZE + AAC_SCSI_RPTLUNS_ADDR_SIZE;
-	int list_len = 0;
+	int list_len = 8;
 	int lun_total = 0;
 	dev_info_t *ldip;
-	int i;
+	int i, cmd_ok = 1;
 
 	ap.a_hba_tran = softs->hba_tran;
 	ap.a_target = (uint16_t)tgt;
@@ -7307,9 +7273,11 @@
 		struct scsi_pkt *pkt;
 		uchar_t *cdb;
 		uchar_t *p;
+		int buf_len;
 		uint32_t data;
 
 		if (bp == NULL) {
+			buf_len = AAC_SCSI_RPTLUNS_HEAD_SIZE + list_len;
 			if ((bp = scsi_alloc_consistent_buf(&ap, NULL,
 			    buf_len, B_READ, NULL_FUNC, NULL)) == NULL)
 			return (AACERR);
@@ -7334,8 +7302,10 @@
 		if (scsi_poll(pkt) < 0 ||
 		    ((struct scsi_status *)pkt->pkt_scbp)->sts_chk) {
 			scsi_destroy_pkt(pkt);
+			cmd_ok = 0;
 			break;
 		}
+		scsi_destroy_pkt(pkt);
 
 		/* Convert list_len from LE_32 to local */
 		for (p = (uchar_t *)bp->b_un.b_addr;
@@ -7343,23 +7313,24 @@
 			data <<= 8;
 			data |= *p;
 		}
-		list_len = data;
-		if (buf_len < list_len + AAC_SCSI_RPTLUNS_HEAD_SIZE) {
+
+		if (data <= list_len)
+			break;
+		if (i == 0) {
+			list_len = data;
 			scsi_free_consistent_buf(bp);
 			bp = NULL;
-			buf_len = list_len + AAC_SCSI_RPTLUNS_HEAD_SIZE;
 		}
-		scsi_destroy_pkt(pkt);
 	}
-	if (i >= 2) {
-		uint8_t *buf = (uint8_t *)(bp->b_un.b_addr +
-		    AAC_SCSI_RPTLUNS_HEAD_SIZE);
 
+	if (cmd_ok) {
+		char *buf = bp->b_un.b_addr + 8;
+
 		for (i = 0; i < (list_len / AAC_SCSI_RPTLUNS_ADDR_SIZE); i++) {
-			uint16_t lun;
+			int lun;
 
 			/* Determine report luns addressing type */
-			switch (buf[0] & AAC_SCSI_RPTLUNS_ADDR_MASK) {
+			switch (buf[i] & AAC_SCSI_RPTLUNS_ADDR_MASK) {
 			/*
 			 * Vendors in the field have been found to be
 			 * concatenating bus/target/lun to equal the
@@ -7369,19 +7340,13 @@
 			case AAC_SCSI_RPTLUNS_ADDR_PERIPHERAL:
 			case AAC_SCSI_RPTLUNS_ADDR_LOGICAL_UNIT:
 			case AAC_SCSI_RPTLUNS_ADDR_FLAT_SPACE:
-				lun = ((buf[0] & 0x3f) << 8) | buf[1];
-				if (lun > UINT8_MAX) {
-					AACDB_PRINT(softs, CE_WARN,
-					    "abnormal lun number: %d", lun);
-					break;
-				}
+				lun = (buf[i] & 0x3f) << 8;
+				lun |= buf[i + 1];
 				if (aac_config_lun(softs, tgt, lun, &ldip) ==
 				    NDI_SUCCESS)
 					lun_total++;
 				break;
 			}
-
-			buf += AAC_SCSI_RPTLUNS_ADDR_SIZE;
 		}
 	} else {
 		/* The target may do not support SCMD_REPORT_LUNS. */
@@ -7393,17 +7358,36 @@
 }
 
 static void
-aac_devcfg(struct aac_softstate *softs, int tgt, int en)
+aac_enable_pd(struct aac_softstate *softs, int tgt, int en)
 {
-	struct aac_device *dvp;
+	if (tgt >= AAC_MAX_LD) {
+		mutex_enter(&softs->io_lock);
+		softs->nondasds[AAC_PD(tgt)].dev.valid = (uint8_t)en;
+		mutex_exit(&softs->io_lock);
+	}
+}
 
-	mutex_enter(&softs->io_lock);
-	dvp = AAC_DEV(softs, tgt);
-	if (en)
-		dvp->flags |= AAC_DFLAG_CONFIGURING;
-	else
-		dvp->flags &= ~AAC_DFLAG_CONFIGURING;
-	mutex_exit(&softs->io_lock);
+static void
+aac_config_pd(void *arg)
+{
+	struct aac_softstate *softs = (struct aac_softstate *)arg;
+	uint32_t bus, tgt;
+	int index, total;
+
+	total = 0;
+	index = AAC_MAX_LD;
+	for (bus = 0; bus < softs->bus_max; bus++) {
+		AACDB_PRINT(softs, CE_NOTE, "bus %d:", bus);
+		for (tgt = 0; tgt < softs->tgt_max; tgt++, index++) {
+			aac_enable_pd(softs, index, 1);
+			if (aac_config_tgt(softs, index) == 0)
+				aac_enable_pd(softs, index, 0);
+			else
+				total++;
+		}
+	}
+	AACDB_PRINT(softs, CE_CONT,
+		"Total %d phys. device(s) found", total);
 }
 
 static int
@@ -7418,16 +7402,6 @@
 	    ddi_get_instance(parent))) == NULL)
 		return (NDI_FAILURE);
 
-	/* Commands for bus config should be blocked as the bus is quiesced */
-	mutex_enter(&softs->io_lock);
-	if (softs->state & AAC_STATE_QUIESCED) {
-		AACDB_PRINT(softs, CE_NOTE,
-		    "bus_config abroted because bus is quiesced");
-		mutex_exit(&softs->io_lock);
-		return (NDI_FAILURE);
-	}
-	mutex_exit(&softs->io_lock);
-
 	DBCALLED(softs, 1);
 
 	/* Hold the nexus across the bus_config */
@@ -7435,49 +7409,39 @@
 	switch (op) {
 	case BUS_CONFIG_ONE: {
 		int tgt, lun;
+		struct scsi_device sd;
 
 		if (aac_parse_devname(arg, &tgt, &lun) != AACOK) {
 			rval = NDI_FAILURE;
 			break;
 		}
-		if (tgt >= AAC_MAX_LD) {
-			if (tgt >= AAC_MAX_DEV(softs)) {
-				rval = NDI_FAILURE;
-				break;
-			}
+		if (*childp = aac_find_child(softs, tgt, lun)) {
+			rval = NDI_SUCCESS;
+			break;
 		}
 
-		AAC_DEVCFG_BEGIN(softs, tgt);
-		rval = aac_config_lun(softs, tgt, lun, childp);
-		AAC_DEVCFG_END(softs, tgt);
+		aac_enable_pd(softs, tgt, 1);
+		bzero(&sd, sizeof (struct scsi_device));
+		sd.sd_address.a_hba_tran = softs->hba_tran;
+		sd.sd_address.a_target = (uint16_t)tgt;
+		sd.sd_address.a_lun = (uint8_t)lun;
+		if ((rval = aac_probe_lun(softs, &sd)) == NDI_SUCCESS)
+			rval = aac_config_child(softs, &sd, childp);
+		else
+			aac_enable_pd(softs, tgt, 0);
+		scsi_unprobe(&sd);
 		break;
 	}
 
 	case BUS_CONFIG_DRIVER:
 	case BUS_CONFIG_ALL: {
-		uint32_t bus, tgt;
-		int index, total;
+		uint32_t tgt;
 
-		for (tgt = 0; tgt < AAC_MAX_LD; tgt++) {
-			AAC_DEVCFG_BEGIN(softs, tgt);
+		for (tgt = 0; tgt < AAC_MAX_LD; tgt++)
 			(void) aac_config_lun(softs, tgt, 0, NULL);
-			AAC_DEVCFG_END(softs, tgt);
-		}
 
 		/* Config the non-DASD devices connected to the card */
-		total = 0;
-		index = AAC_MAX_LD;
-		for (bus = 0; bus < softs->bus_max; bus++) {
-			AACDB_PRINT(softs, CE_NOTE, "bus %d:", bus);
-			for (tgt = 0; tgt < softs->tgt_max; tgt++, index++) {
-				AAC_DEVCFG_BEGIN(softs, index);
-				if (aac_config_tgt(softs, index))
-					total++;
-				AAC_DEVCFG_END(softs, index);
-			}
-		}
-		AACDB_PRINT(softs, CE_CONT,
-		    "?Total %d phys. device(s) found", total);
+		aac_config_pd((void *)softs);
 		rval = NDI_SUCCESS;
 		break;
 	}
@@ -7489,10 +7453,10 @@
 	return (rval);
 }
 
-/*ARGSUSED*/
-static int
-aac_handle_dr(struct aac_softstate *softs, int tgt, int lun, int event)
+static void
+aac_handle_dr(struct aac_drinfo *drp)
 {
+	struct aac_softstate *softs = drp->softs;
 	struct aac_device *dvp;
 	dev_info_t *dip;
 	int valid;
@@ -7501,26 +7465,25 @@
 	DBCALLED(softs, 1);
 
 	/* Hold the nexus across the bus_config */
-	dvp = AAC_DEV(softs, tgt);
-	valid = AAC_DEV_IS_VALID(dvp);
+	mutex_enter(&softs->io_lock);
+	dvp = AAC_DEV(softs, drp->tgt);
 	dip = dvp->dip;
-	if (!(softs->state & AAC_STATE_RUN))
-		return (AACERR);
+	valid = dvp->valid;
 	mutex_exit(&softs->io_lock);
 
-	switch (event) {
-	case AAC_CFG_ADD:
-	case AAC_CFG_DELETE:
+	switch (drp->event) {
+	case AAC_DEV_ONLINE:
+	case AAC_DEV_OFFLINE:
 		/* Device onlined */
 		if (dip == NULL && valid) {
 			ndi_devi_enter(softs->devinfo_p, &circ1);
-			(void) aac_config_lun(softs, tgt, 0, NULL);
+			(void) aac_config_lun(softs, drp->tgt, 0, NULL);
 			AACDB_PRINT(softs, CE_NOTE, "c%dt%dL%d onlined",
-			    softs->instance, tgt, lun);
+			    softs->instance, drp->tgt, drp->lun);
 			ndi_devi_exit(softs->devinfo_p, circ1);
 		}
 		/* Device offlined */
-		if (dip && !valid) {
+		if (dip && valid == 0) {
 			mutex_enter(&softs->io_lock);
 			(void) aac_do_reset(softs);
 			mutex_exit(&softs->io_lock);
@@ -7527,16 +7490,38 @@
 
 			(void) ndi_devi_offline(dip, NDI_DEVI_REMOVE);
 			AACDB_PRINT(softs, CE_NOTE, "c%dt%dL%d offlined",
-			    softs->instance, tgt, lun);
+			    softs->instance, drp->tgt, drp->lun);
 		}
 		break;
 	}
+	kmem_free(drp, sizeof (struct aac_drinfo));
+}
 
-	mutex_enter(&softs->io_lock);
+static int
+aac_dr_event(struct aac_softstate *softs, int tgt, int lun, int event)
+{
+	struct aac_drinfo *drp;
+
+	DBCALLED(softs, 1);
+
+	if (softs->taskq == NULL ||
+	    (drp = kmem_zalloc(sizeof (struct aac_drinfo), KM_NOSLEEP)) == NULL)
+		return (AACERR);
+
+	drp->softs = softs;
+	drp->tgt = tgt;
+	drp->lun = lun;
+	drp->event = event;
+	if ((ddi_taskq_dispatch(softs->taskq, (void (*)(void *))aac_handle_dr,
+	    drp, DDI_NOSLEEP)) != DDI_SUCCESS) {
+		AACDB_PRINT(softs, CE_WARN, "DR task start failed");
+		kmem_free(drp, sizeof (struct aac_drinfo));
+		return (AACERR);
+	}
 	return (AACOK);
 }
 
-#ifdef DEBUG
+#ifdef AAC_DEBUG_ALL
 
 /* -------------------------debug aid functions-------------------------- */
 
@@ -7980,7 +7965,9 @@
 	AAC_AIFEN_KEY_STRINGS,
 	-1,			NULL
 };
+#endif /* AAC_DEBUG_ALL */
 
+#ifdef AAC_DEBUG
 /*
  * The following function comes from Adaptec:
  *
@@ -7990,8 +7977,9 @@
 static int
 aac_get_fw_debug_buffer(struct aac_softstate *softs)
 {
+	softs->sync_slot_busy = 1;
 	if (aac_sync_mbcommand(softs, AAC_MONKER_GETDRVPROP,
-	    0, 0, 0, 0, NULL) == AACOK) {
+	    0, 0, 0, 0, NULL, NULL) == AACOK) {
 		uint32_t mondrv_buf_paddrl = AAC_MAILBOX_GET(softs, 1);
 		uint32_t mondrv_buf_paddrh = AAC_MAILBOX_GET(softs, 2);
 		uint32_t mondrv_buf_size = AAC_MAILBOX_GET(softs, 3);
@@ -7999,7 +7987,7 @@
 
 		if (mondrv_buf_size) {
 			uint32_t offset = mondrv_buf_paddrl - \
-			    softs->pci_mem_base_paddr;
+			    softs->pci_mem_base_paddr[1];
 
 			/*
 			 * See if the address is already mapped in, and
@@ -8012,7 +8000,6 @@
 				softs->debug_header_size = mondrv_hdr_size;
 				softs->debug_buf_size = mondrv_buf_size;
 				softs->debug_fw_flags = 0;
-				softs->debug_flags &= ~AACDB_FLAGS_FW_PRINT;
 				mutex_exit(&aac_prt_mutex);
 
 				return (AACOK);
@@ -8096,7 +8083,7 @@
 			 * previous message length to clear (the handshake).
 			 */
 			for (i = 0; i < AAC_PRINT_TIMEOUT; i++) {
-				if (!PCI_MEM_GET32(softs,
+				if (!PCI_MEM_GET32(softs, 1,
 				    softs->debug_buf_offset + \
 				    AAC_FW_DBG_STRLEN_OFFSET))
 					break;
@@ -8110,17 +8097,17 @@
 			 * last because that is the signal for the Firmware to
 			 * pick it up.
 			 */
-			if (!PCI_MEM_GET32(softs, softs->debug_buf_offset + \
+			if (!PCI_MEM_GET32(softs, 1, softs->debug_buf_offset + \
 			    AAC_FW_DBG_STRLEN_OFFSET)) {
-				PCI_MEM_REP_PUT8(softs,
+				PCI_MEM_REP_PUT8(softs, 1,
 				    softs->debug_buf_offset + \
 				    softs->debug_header_size,
 				    aac_prt_buf, count);
-				PCI_MEM_PUT32(softs,
+				PCI_MEM_PUT32(softs, 1,
 				    softs->debug_buf_offset + \
 				    AAC_FW_DBG_FLAGS_OFFSET,
 				    softs->debug_fw_flags);
-				PCI_MEM_PUT32(softs,
+				PCI_MEM_PUT32(softs, 1,
 				    softs->debug_buf_offset + \
 				    AAC_FW_DBG_STRLEN_OFFSET, count);
 			} else {
@@ -8143,7 +8130,9 @@
 	}
 	mutex_exit(&aac_prt_mutex);
 }
+#endif /* AAC_DEBUG */
 
+#ifdef AAC_DEBUG_ALL
 /*
  * Translate command number to description string
  */
@@ -8168,7 +8157,7 @@
 	int ctl = ddi_get_instance(softs->devinfo_p);
 	int tgt = ap->a_target;
 	int lun = ap->a_lun;
-	union scsi_cdb *cdbp = (void *)pkt->pkt_cdbp;
+	union scsi_cdb *cdbp = (union scsi_cdb *)pkt->pkt_cdbp;
 	uchar_t cmd = cdbp->scc_cmd;
 	char *desc;
 
